package body Symbolic_Expressions.Solving is
   procedure Mastica (X : Boolean) is
   begin
      null;
   end Mastica;
   ----------------------
   -- Triangular_Solve --
   ----------------------

   procedure Triangular_Solve
     (What    : in     Equation_Tables.Map;
      Result  :    out Variable_Tables.Map;
      Success :    out Boolean)
   is
      use Equation_Tables;

      Copy : Equation_Tables.Map := What;
      Buffer : Equation_Tables.Map;
      Something_Done : Boolean;
      Expr : Symbolic_Expression;
      Pos : Cursor;
   begin
      --
      --  The algorithm used is very simple and general, although maybe
      --  not the most efficient (since its cost can grow as N*N).  We
      --  iterate over the set of equations, replacing variables according
      --  to the partial solution stored in Result.  If, as a consequence
      --  of such substitution, an expression becomes constant, it is
      --  removed from the set of equations and stored in Result.  The
      --  iteration will end when the system becomes empty or when
      --  no equation are moved from the system to the solution
      --
      Something_Done := True;

      while (not Copy.Is_Empty) and Something_Done loop
         Buffer.Clear;
         Something_Done := False;

         --  Mastica does nothing, but without this Something_Done
         --  seems to remain stuck to True.  Optimizer bug?
         Mastica (Something_Done);

         Pos := Copy.First;
         while Pos /= No_Element loop
            Expr := Replace (Element (Pos), Result);

            if Is_Constant (Expr) then
               Result.Insert (Key (Pos), Eval (Expr));
               Something_Done := True;
            else
               Buffer.Insert (Key(Pos), Expr);
            end if;

            Next (Pos);
         end loop;

         Copy := Buffer;
      end loop;

      Success := Copy.Is_Empty;
   end Triangular_Solve;

end Symbolic_Expressions.Solving;
